LibreOffice LibreOffice 25.8 SDK API Reference

Public Member Functions | List of all members
XIntegerReadOnlyBitmap Interface Reference

This is a specialized interface for bitmaps having integer color channels. More...

`import"XIntegerReadOnlyBitmap.idl";`

Inheritance diagram for XIntegerReadOnlyBitmap:

## Public Member Functions
sequence< byte > | getData ([out] IntegerBitmapLayout bitmapLayout, [in] ::com::sun::star::geometry::IntegerRectangle2D rect) raises (com::sun::star::lang::IndexOutOfBoundsException, VolatileContentDestroyedException)
| Query the raw data of this bitmap. More...
sequence< byte > | getPixel ([out] IntegerBitmapLayout bitmapLayout, [in] ::com::sun::star::geometry::IntegerPoint2D pos) raises (com::sun::star::lang::IndexOutOfBoundsException, VolatileContentDestroyedException)
| Get a single pixel of the bitmap, returning its color value. More...
IntegerBitmapLayout | getMemoryLayout ()
| Query the memory layout for this bitmap. More...
Public Member Functions inherited from XBitmap
::com::sun::star::geometry::IntegerSize2D | getSize ()
| Query the size of the bitmap. More...
boolean | hasAlpha ()
| Query transparency status of the bitmap. More...
XBitmap | getScaledBitmap ([in] ::com::sun::star::geometry::RealSize2D newSize, [in] boolean beFast) raises (com::sun::star::lang::IllegalArgumentException, VolatileContentDestroyedException)
| Query a scaled copy of the original bitmap. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

This is a specialized interface for bitmaps having integer color channels.

In contrast to XIntegerBitmap, this interface only permits read-only access.

Use this interface for e.g. bitmaps that are calculated on-the-fly, or that are pure functional, and thus cannot be modified.

If you get passed an instance of XIntegerReadOnlyBitmap that also supports the XVolatileBitmap interface, things become a bit more complicated. When reading data, one has to check for both VolatileContentDestroyedException and mismatching IntegerBitmapLayout return values. If either of them occurs, the whole bitmap read operation should be repeated, if you need consistent information.

## Member Function Documentation

## ◆ getData()

sequence< byte > getData | ( | [out] IntegerBitmapLayout | bitmapLayout,
|  | [in] ::com::sun::star::geometry::IntegerRectangle2D | rect
| ) |  |
raises | ( | com::sun::star::lang::IndexOutOfBoundsException,
|  | VolatileContentDestroyedException
| ) |  |

Query the raw data of this bitmap.

Query the raw data of this bitmap, in the format as defined by getMemoryLayout(). With the given rectangle, a subset of the whole bitmap can be queried. If the internal data format's pixel are not integer multiples of bytes (i.e. if one pixel occupies less than a byte), the leftover content of the bytes at the right of each scanline is filled with zeros. The details of the scanline padding are to be retrieved from the passed bitmap layout.

Note that the bitmap memory layout might change over time for volatile bitmaps.

Parameters

  bitmapLayout | The memory layout the returned data is in. Note that the color space returned therein needs to always match the current color space as would have been returned by getMemoryLayout(). This is necessary to ensure correct operation under changing XVolatileBitmap.
  rect | A rectangle, within the bounds of the bitmap, to retrieve the consent from.

Exceptions

  VolatileContentDestroyedException | if the bitmap is volatile, and the content has been destroyed by the system.
  com::sun::star::lang::IndexOutOfBoundsException | if parts of the given rectangle are outside the permissible bitmap area.

## ◆ getMemoryLayout()

IntegerBitmapLayout getMemoryLayout | ( |  | ) |

Query the memory layout for this bitmap.

Please note that for volatile bitmaps, the memory layout might change between subsequent calls.

## ◆ getPixel()

sequence< byte > getPixel | ( | [out] IntegerBitmapLayout | bitmapLayout,
|  | [in] ::com::sun::star::geometry::IntegerPoint2D | pos
| ) |  |
raises | ( | com::sun::star::lang::IndexOutOfBoundsException,
|  | VolatileContentDestroyedException
| ) |  |

Get a single pixel of the bitmap, returning its color value.

If the internal data format's pixel are not integer multiples of bytes (i.e. if one pixel occupies less than a byte - the case of more than one byte per pixel is not specified), the color value is returned in the least significant bits of the single byte returned as the color. The details of the returned pixel data are to be retrieved from the passed bitmap layout.

Note that the bitmap memory layout might change for volatile bitmaps.

Parameters

  bitmapLayout | The memory layout the returned data is in. Note that the color space returned therein needs to always match the current color space as would have been returned by getMemoryLayout(). This is necessary to ensure correct operation under changing XVolatileBitmap.
  pos | A position, within the bounds of the bitmap, to retrieve the color from.

Exceptions

  VolatileContentDestroyedException | if the bitmap is volatile, and the content has been destroyed by the system.
  com::sun::star::lang::IndexOutOfBoundsException | if the given position is outside the permissible bitmap area.

The documentation for this interface was generated from the following file:

- com/sun/star/rendering/XIntegerReadOnlyBitmap.idl